/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/slave/mozilla-central-macosx-xulrunner/build/toolkit/mozapps/extensions/amIWebInstallListener.idl
 */

package org.mozilla.interfaces;

/**
 * The registered amIWebInstallListener is used to notify about new installs
 * triggered by websites. The default implementation displays a confirmation
 * dialog when add-ons are ready to install and uses the observer service to
 * notify when installations are blocked.
 */
public interface amIWebInstallListener extends nsISupports {

  String AMIWEBINSTALLLISTENER_IID =
    "{ea806f3a-1b27-4d3d-9aee-88dec4c29fda}";

  /**
   * Called when the website is not allowed to directly prompt the user to
   * install add-ons.
   *
   * @param  aWindow
   *         The window that triggered the installs
   * @param  aUri
   *         The URI of the site that triggered the installs
   * @param  aInstalls
   *         The AddonInstalls that were blocked
   * @param  aCount
   *         The number of AddonInstalls
   * @return true if the caller should start the installs
   */
  boolean onWebInstallBlocked(nsIDOMWindowInternal aWindow, nsIURI aUri, nsIVariant[] aInstalls, long aCount);

  /**
   * Called when a website wants to ask the user to install add-ons.
   *
   * @param  aWindow
   *         The window that triggered the installs
   * @param  aUri
   *         The URI of the site that triggered the installs
   * @param  aInstalls
   *         The AddonInstalls that were requested
   * @param  aCount
   *         The number of AddonInstalls
   * @return true if the caller should start the installs
   */
  boolean onWebInstallRequested(nsIDOMWindowInternal aWindow, nsIURI aUri, nsIVariant[] aInstalls, long aCount);

}